/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 1



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     STRING = 258,
     VALUE = 259,
     IDENTIFIER = 260,
     OBJECT = 261,
     UNIT_ANGLE = 262,
     UNIT_COLOR = 263,
     UNIT_RATIO = 264,
     UNIT_SIZE = 265,
     UNIT_SPEED = 266,
     UNIT_TIME = 267,
     FOR = 268,
     IF = 269,
     ACTION_SCRIPT = 270,
     ELSE = 271,
     RANGE = 272,
     LOGICAL_OR = 273,
     LOGICAL_XOR = 274,
     LOGICAL_AND = 275,
     GREATER_EQUAL = 276,
     LESS_EQUAL = 277,
     NOT_EQUAL = 278,
     EQUAL = 279,
     ROTATE_RIGHT = 280,
     ROTATE_LEFT = 281,
     SHIFT_RIGHT_UNSIGNED = 282,
     SHIFT_RIGHT = 283,
     SHIFT_LEFT = 284,
     MAX_OP = 285,
     MIN_OP = 286,
     POWER = 287,
     NEG = 288,
     POS = 289
   };
#endif
/* Tokens.  */
#define STRING 258
#define VALUE 259
#define IDENTIFIER 260
#define OBJECT 261
#define UNIT_ANGLE 262
#define UNIT_COLOR 263
#define UNIT_RATIO 264
#define UNIT_SIZE 265
#define UNIT_SPEED 266
#define UNIT_TIME 267
#define FOR 268
#define IF 269
#define ACTION_SCRIPT 270
#define ELSE 271
#define RANGE 272
#define LOGICAL_OR 273
#define LOGICAL_XOR 274
#define LOGICAL_AND 275
#define GREATER_EQUAL 276
#define LESS_EQUAL 277
#define NOT_EQUAL 278
#define EQUAL 279
#define ROTATE_RIGHT 280
#define ROTATE_LEFT 281
#define SHIFT_RIGHT_UNSIGNED 282
#define SHIFT_RIGHT 283
#define SHIFT_LEFT 284
#define MAX_OP 285
#define MIN_OP 286
#define POWER 287
#define NEG 288
#define POS 289




/* Copy the first part of user declarations.  */
#line 1 "src/sswf/sswf_grammar.y"
	/* sswf_grammar.y -- written by Alexis WILKE for Made to Order Software Corp. (c) 2002-2009 */
	/* grammar parser for the SWF scripting tool */

/*

Copyright (c) 2002-2009 Made to Order Software Corp.

Permission is hereby granted, free of charge, to any
person obtaining a copy of this software and
associated documentation files (the "Software"), to
deal in the Software without restriction, including
without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom
the Software is furnished to do so, subject to the
following conditions:

The above copyright notice and this permission notice
shall be included in all copies or substantial
portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF
ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO
EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.

*/


#include	"sswf.h"

#define	YYPARSE_PARAM		result
static	void			yyerror(const char *msg);





/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 48 "src/sswf/sswf_grammar.y"
{
	struct node_t		*node;
	enum node_type_t	type;		/* for UNIT */
	int			unused;
}
/* Line 187 of yacc.c.  */
#line 214 "tmp/object/src/sswf/sswf_grammar.c"
	YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 239 "tmp/object/src/sswf/sswf_grammar.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
    YYLTYPE yyls;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  34
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   946

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  60
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  15
/* YYNRULES -- Number of rules.  */
#define YYNRULES  78
/* YYNRULES -- Number of states.  */
#define YYNSTATES  172

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   289

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    46,     2,     2,    57,    44,    26,     2,
      58,    59,    42,    40,    55,    41,    51,    43,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    19,    52,
      27,    17,    28,    18,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    50,     2,    56,    25,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    53,    24,    54,    47,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    20,    21,    22,    23,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    45,    48,    49
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     7,     9,    11,    14,    16,    20,
      22,    26,    28,    32,    35,    38,    41,    44,    47,    50,
      54,    59,    64,    68,    71,    74,    77,    80,    84,    89,
      93,    97,   101,   105,   109,   113,   117,   121,   125,   129,
     133,   137,   141,   145,   149,   153,   157,   161,   165,   169,
     173,   177,   181,   185,   189,   193,   199,   209,   213,   215,
     217,   219,   221,   222,   228,   239,   246,   252,   255,   256,
     257,   265,   266,   268,   270,   272,   276,   280,   282
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      61,     0,    -1,    64,    62,    -1,    -1,    63,    -1,    52,
      -1,    63,    52,    -1,    65,    -1,    64,    63,    65,    -1,
      67,    -1,    53,    64,    54,    -1,    67,    -1,    66,    55,
      67,    -1,    67,     7,    -1,    67,     8,    -1,    67,     9,
      -1,    67,    10,    -1,    67,    11,    -1,    67,    12,    -1,
      67,    51,    67,    -1,    67,    50,    66,    56,    -1,    57,
      58,    66,    59,    -1,    58,    66,    59,    -1,    40,    67,
      -1,    41,    67,    -1,    46,    67,    -1,    47,    67,    -1,
       5,    58,    59,    -1,     5,    58,    66,    59,    -1,    67,
      45,    67,    -1,    67,    42,    67,    -1,    67,    43,    67,
      -1,    67,    44,    67,    -1,    67,    40,    67,    -1,    67,
      41,    67,    -1,    67,    39,    67,    -1,    67,    38,    67,
      -1,    67,    37,    67,    -1,    67,    36,    67,    -1,    67,
      35,    67,    -1,    67,    34,    67,    -1,    67,    33,    67,
      -1,    67,    32,    67,    -1,    67,    31,    67,    -1,    67,
      27,    67,    -1,    67,    30,    67,    -1,    67,    28,    67,
      -1,    67,    29,    67,    -1,    67,    26,    67,    -1,    67,
      25,    67,    -1,    67,    24,    67,    -1,    67,    23,    67,
      -1,    67,    22,    67,    -1,    67,    21,    67,    -1,    67,
      20,    67,    -1,    67,    18,    66,    19,    67,    -1,    14,
      58,    66,    59,    53,    64,    62,    54,    68,    -1,     5,
      17,    67,    -1,    69,    -1,     5,    -1,     4,    -1,     3,
      -1,    -1,    16,    53,    64,    62,    54,    -1,    16,    14,
      58,    66,    59,    53,    64,    62,    54,    68,    -1,     6,
      72,    53,    73,    62,    54,    -1,     6,    72,    53,    62,
      54,    -1,     6,    72,    -1,    -1,    -1,    15,    72,    53,
      70,     3,    71,    54,    -1,    -1,     5,    -1,     3,    -1,
      74,    -1,    73,    63,    74,    -1,     5,    19,    66,    -1,
      66,    -1,    13,    58,     5,    17,    67,    52,    67,    52,
      67,    59,    53,    73,    62,    54,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   100,   100,   107,   109,   113,   114,   119,   123,   131,
     135,   146,   150,   158,   163,   168,   173,   178,   183,   188,
     194,   200,   205,   221,   226,   231,   236,   241,   247,   253,
     259,   265,   271,   277,   283,   289,   295,   301,   307,   313,
     319,   325,   331,   337,   343,   349,   355,   361,   367,   373,
     379,   385,   391,   397,   403,   417,   424,   431,   438,   442,
     446,   450,   459,   462,   466,   477,   487,   496,   506,   508,
     505,   532,   535,   539,   551,   555,   564,   570,   576
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "STRING", "VALUE", "IDENTIFIER",
  "OBJECT", "UNIT_ANGLE", "UNIT_COLOR", "UNIT_RATIO", "UNIT_SIZE",
  "UNIT_SPEED", "UNIT_TIME", "FOR", "IF", "ACTION_SCRIPT", "ELSE", "'='",
  "'?'", "':'", "RANGE", "LOGICAL_OR", "LOGICAL_XOR", "LOGICAL_AND", "'|'",
  "'^'", "'&'", "'<'", "'>'", "GREATER_EQUAL", "LESS_EQUAL", "NOT_EQUAL",
  "EQUAL", "ROTATE_RIGHT", "ROTATE_LEFT", "SHIFT_RIGHT_UNSIGNED",
  "SHIFT_RIGHT", "SHIFT_LEFT", "MAX_OP", "MIN_OP", "'+'", "'-'", "'*'",
  "'/'", "'%'", "POWER", "'!'", "'~'", "NEG", "POS", "'['", "'.'", "';'",
  "'{'", "'}'", "','", "']'", "'$'", "'('", "')'", "$accept", "start",
  "opt_end", "colons", "expr_list", "block_expr", "group_expr", "expr",
  "opt_else", "object", "@1", "@2", "opt_name", "object_definition",
  "definition", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,    61,    63,    58,
     272,   273,   274,   275,   124,    94,    38,    60,    62,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
      43,    45,    42,    47,    37,   287,    33,   126,   288,   289,
      91,    46,    59,   123,   125,    44,    93,    36,    40,    41
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    60,    61,    62,    62,    63,    63,    64,    64,    65,
      65,    66,    66,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    68,    68,    68,    69,    69,    69,    70,    71,
      69,    72,    72,    72,    73,    73,    74,    74,    74
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     0,     1,     1,     2,     1,     3,     1,
       3,     1,     3,     2,     2,     2,     2,     2,     2,     3,
       4,     4,     3,     2,     2,     2,     2,     3,     4,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     5,     9,     3,     1,     1,
       1,     1,     0,     5,    10,     6,     5,     2,     0,     0,
       7,     0,     1,     1,     1,     3,     3,     1,    14
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,    61,    60,    59,    71,     0,    71,     0,     0,     0,
       0,     0,     0,     0,     0,     3,     7,     9,    58,     0,
       0,    73,    72,    67,     0,     0,    23,    24,    25,    26,
       0,     0,     0,    11,     1,     5,     2,     4,    13,    14,
      15,    16,    17,    18,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    57,    27,     0,     3,     0,    68,    10,
       0,     0,     0,    22,     6,     8,     0,    54,    53,    52,
      51,    50,    49,    48,    44,    46,    47,    45,    43,    42,
      41,    40,    39,    38,    37,    36,    35,    33,    34,    30,
      31,    32,    29,     0,    19,    28,    59,     0,     0,     4,
      77,     3,    74,     0,     0,    21,    12,     0,    20,     0,
       0,    66,     0,     4,     0,    69,    55,    76,     0,    65,
      75,     3,     0,     0,     0,    70,     0,    62,     0,     0,
      56,     0,     0,     0,     0,     0,     3,     0,     0,     0,
       0,     0,    63,     0,     0,     3,     3,     0,     0,    78,
      62,    64
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    14,    36,    37,    15,    16,   120,    33,   150,    18,
     124,   142,    23,   121,   122
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -60
static const yytype_int16 yypact[] =
{
     227,   -60,   -60,    25,    18,   -28,    18,   255,   255,   255,
     255,   227,   -17,   255,    15,    26,   -60,   433,   -60,   255,
      83,   -60,   -60,    23,   255,    31,   531,   531,   531,   531,
     -25,   255,   -43,   433,   -60,   -60,   -60,   153,   -60,   -60,
     -60,   -60,   -60,   -60,   255,   255,   255,   255,   255,   255,
     255,   255,   255,   255,   255,   255,   255,   255,   255,   255,
     255,   255,   255,   255,   255,   255,   255,   255,   255,   255,
     255,   255,   255,   433,   -60,   -42,   167,   -41,   -60,   -60,
     153,   -35,   255,   -60,   -60,   -60,   -16,   523,   568,   613,
     658,   703,   748,   793,   838,   838,   838,   838,   838,   838,
     838,   838,   838,   838,   838,   850,   850,   895,   895,   761,
     761,   761,   761,   -50,    24,   -60,    21,    19,    36,    39,
      40,    26,   -60,    41,    93,   -60,   433,   255,   -60,   255,
      94,   -60,    46,   182,   227,   -60,   478,    40,    84,   -60,
     -60,    26,    48,   255,    49,   -60,   341,    88,   255,   -10,
     -60,   387,    51,   227,   255,   255,    26,   296,   -33,    52,
      54,    57,   -60,   241,   227,    26,    26,    58,    59,   -60,
      88,   -60
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -60,   -60,   -48,    -5,    -9,   -36,    61,     0,   -59,   -60,
     -60,   -60,   108,   -44,   -18
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      17,    85,    30,   127,   152,    82,   128,    26,    27,    28,
      29,    17,    82,    82,    82,    34,    83,   115,   123,    73,
      82,    21,    82,    22,   125,    80,   161,    35,   118,    79,
      24,    38,    39,    40,    41,    42,    43,    17,    19,    82,
     129,    31,    19,   153,    85,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   119,   114,   132,    32,    72,    76,   130,    35,    20,
      17,    75,   126,    20,    78,    77,     1,     2,     3,     4,
     131,    84,    81,   144,   134,    82,   135,     5,     6,   138,
     139,   143,   145,   147,   149,    86,   162,   163,   159,   155,
     164,   171,   169,   170,    25,   140,   133,   167,   168,   165,
       0,     0,     0,     7,     8,   141,     0,   136,     0,     9,
      10,     0,   113,     0,    17,     0,     0,     0,     0,     0,
      12,    13,    74,   146,   156,     0,     0,     0,   151,     0,
       0,     0,     0,    17,   157,   166,     1,     2,     3,     4,
     133,     0,     0,     0,    17,     0,     0,     5,     6,     0,
       1,     2,   116,     4,     0,     0,     0,     0,     0,     0,
     117,     5,     6,     0,     0,     1,     2,   116,     4,     0,
     137,     0,     0,     7,     8,   117,     5,     6,     0,     9,
      10,     0,     0,     0,     0,    84,    11,     7,     8,     0,
      12,    13,     0,     9,    10,     0,   158,     0,     0,    35,
       0,     0,     7,     8,    12,    13,     0,     0,     9,    10,
       1,     2,     3,     4,    84,     0,     0,     0,     0,    12,
      13,     5,     6,     0,     1,     2,   116,     4,     0,     0,
       0,     0,     0,     0,   117,     5,     6,     0,     1,     2,
       3,     4,     0,     0,     0,     0,     0,     7,     8,     5,
       6,     0,     0,     9,    10,     0,     0,     0,     0,     0,
      11,     7,     8,     0,    12,    13,     0,     9,    10,     0,
       0,     0,     0,     0,     0,     7,     8,     0,    12,    13,
       0,     9,    10,    38,    39,    40,    41,    42,    43,     0,
       0,     0,    12,    13,    44,     0,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,     0,     0,     0,     0,    71,    72,    38,    39,
      40,    41,    42,    43,     0,   160,     0,     0,     0,    44,
       0,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,     0,     0,     0,
       0,    71,    72,   148,    38,    39,    40,    41,    42,    43,
       0,     0,     0,     0,     0,    44,     0,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,     0,     0,     0,     0,    71,    72,   154,
      38,    39,    40,    41,    42,    43,     0,     0,     0,     0,
       0,    44,     0,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,     0,
       0,     0,     0,    71,    72,    38,    39,    40,    41,    42,
      43,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,     0,     0,     0,     0,    71,    72,
      38,    39,    40,    41,    42,    43,     0,     0,    38,    39,
      40,    41,    42,    43,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,     0,
       0,     0,     0,    71,    72,    38,    39,    40,    41,    42,
      43,    71,    72,     0,     0,     0,     0,     0,     0,     0,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,     0,     0,     0,     0,    71,    72,
      38,    39,    40,    41,    42,    43,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,     0,
       0,     0,     0,    71,    72,    38,    39,    40,    41,    42,
      43,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,     0,     0,     0,     0,    71,    72,
      38,    39,    40,    41,    42,    43,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,     0,
       0,     0,     0,    71,    72,    38,    39,    40,    41,    42,
      43,     0,     0,     0,     0,     0,     0,     0,    38,    39,
      40,    41,    42,    43,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,     0,     0,     0,     0,    71,    72,
      38,    39,    40,    41,    42,    43,    70,     0,     0,     0,
       0,    71,    72,     0,     0,     0,     0,     0,     0,     0,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,     0,
       0,     0,     0,    71,    72,    38,    39,    40,    41,    42,
      43,     0,     0,     0,     0,     0,     0,    38,    39,    40,
      41,    42,    43,     0,     0,     0,     0,     0,     0,     0,
       0,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,     0,     0,     0,     0,    71,    72,
      65,    66,    67,    68,    69,    70,     0,     0,     0,     0,
      71,    72,    38,    39,    40,    41,    42,    43,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    67,    68,    69,
      70,     0,     0,     0,     0,    71,    72
};

static const yytype_int16 yycheck[] =
{
       0,    37,    11,    19,    14,    55,    56,     7,     8,     9,
      10,    11,    55,    55,    55,     0,    59,    59,    59,    19,
      55,     3,    55,     5,    59,    30,    59,    52,    76,    54,
      58,     7,     8,     9,    10,    11,    12,    37,    17,    55,
      19,    58,    17,    53,    80,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    76,    72,   121,    13,    51,    53,    58,    52,    58,
      80,    20,    82,    58,    53,    24,     3,     4,     5,     6,
      54,    52,    31,   141,    53,    55,     3,    14,    15,     5,
      54,    17,    54,    54,    16,    44,    54,    53,   156,    58,
      53,   170,    54,    54,     6,   133,   121,   165,   166,   163,
      -1,    -1,    -1,    40,    41,   134,    -1,   127,    -1,    46,
      47,    -1,    71,    -1,   134,    -1,    -1,    -1,    -1,    -1,
      57,    58,    59,   143,   153,    -1,    -1,    -1,   148,    -1,
      -1,    -1,    -1,   153,   154,   164,     3,     4,     5,     6,
     165,    -1,    -1,    -1,   164,    -1,    -1,    14,    15,    -1,
       3,     4,     5,     6,    -1,    -1,    -1,    -1,    -1,    -1,
      13,    14,    15,    -1,    -1,     3,     4,     5,     6,    -1,
     129,    -1,    -1,    40,    41,    13,    14,    15,    -1,    46,
      47,    -1,    -1,    -1,    -1,    52,    53,    40,    41,    -1,
      57,    58,    -1,    46,    47,    -1,   155,    -1,    -1,    52,
      -1,    -1,    40,    41,    57,    58,    -1,    -1,    46,    47,
       3,     4,     5,     6,    52,    -1,    -1,    -1,    -1,    57,
      58,    14,    15,    -1,     3,     4,     5,     6,    -1,    -1,
      -1,    -1,    -1,    -1,    13,    14,    15,    -1,     3,     4,
       5,     6,    -1,    -1,    -1,    -1,    -1,    40,    41,    14,
      15,    -1,    -1,    46,    47,    -1,    -1,    -1,    -1,    -1,
      53,    40,    41,    -1,    57,    58,    -1,    46,    47,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    -1,    57,    58,
      -1,    46,    47,     7,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    57,    58,    18,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    -1,    -1,    -1,    -1,    50,    51,     7,     8,
       9,    10,    11,    12,    -1,    59,    -1,    -1,    -1,    18,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    -1,    -1,    -1,
      -1,    50,    51,    52,     7,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    18,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    -1,    -1,    -1,    -1,    50,    51,    52,
       7,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    18,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    -1,
      -1,    -1,    -1,    50,    51,     7,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    -1,    -1,    -1,    -1,    50,    51,
       7,     8,     9,    10,    11,    12,    -1,    -1,     7,     8,
       9,    10,    11,    12,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    -1,
      -1,    -1,    -1,    50,    51,     7,     8,     9,    10,    11,
      12,    50,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    -1,    -1,    -1,    -1,    50,    51,
       7,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    -1,
      -1,    -1,    -1,    50,    51,     7,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    -1,    -1,    -1,    -1,    50,    51,
       7,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    -1,
      -1,    -1,    -1,    50,    51,     7,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     7,     8,
       9,    10,    11,    12,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    -1,    -1,    -1,    -1,    50,    51,
       7,     8,     9,    10,    11,    12,    45,    -1,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    -1,
      -1,    -1,    -1,    50,    51,     7,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,     7,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    -1,    -1,    -1,    -1,    50,    51,
      40,    41,    42,    43,    44,    45,    -1,    -1,    -1,    -1,
      50,    51,     7,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    44,
      45,    -1,    -1,    -1,    -1,    50,    51
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,     6,    14,    15,    40,    41,    46,
      47,    53,    57,    58,    61,    64,    65,    67,    69,    17,
      58,     3,     5,    72,    58,    72,    67,    67,    67,    67,
      64,    58,    66,    67,     0,    52,    62,    63,     7,     8,
       9,    10,    11,    12,    18,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    50,    51,    67,    59,    66,    53,    66,    53,    54,
      63,    66,    55,    59,    52,    65,    66,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    66,    67,    59,     5,    13,    62,    63,
      66,    73,    74,    59,    70,    59,    67,    19,    56,    19,
      58,    54,    62,    63,    53,     3,    67,    66,     5,    54,
      74,    64,    71,    17,    62,    54,    67,    54,    52,    16,
      68,    67,    14,    53,    52,    58,    64,    67,    66,    62,
      59,    59,    54,    53,    53,    73,    64,    62,    62,    54,
      54,    68
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;
/* Location data for the look-ahead symbol.  */
YYLTYPE yylloc;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;

  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[2];

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;
#if YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 0;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
	YYSTACK_RELOCATE (yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 101 "src/sswf/sswf_grammar.y"
    {
	  	/* the returned value is the result */
		* (struct node_t **) result = (yyvsp[(1) - (2)].node);
	  ;}
    break;

  case 7:
#line 120 "src/sswf/sswf_grammar.y"
    {
	  	(yyval.node) = (yyvsp[(1) - (1)].node);
	  ;}
    break;

  case 8:
#line 124 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = (yyvsp[(1) - (3)].node);
		node_link_tail((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 9:
#line 132 "src/sswf/sswf_grammar.y"
    {
	  	(yyval.node) = (yyvsp[(1) - (1)].node);
	  ;}
    break;

  case 10:
#line 136 "src/sswf/sswf_grammar.y"
    {
		/* this is equivalent to a LIST without a name */
		(yyval.node) = node_alloc(NODE_TYPE_OBJECT, NODE_SUBTYPE_BLOCK, (yylsp[(1) - (3)]).first_line);
		/* left = NULL -- always unamed object */
		node_link_right((yyval.node), (yyvsp[(2) - (3)].node));
		node_link_object((yyval.node));
	  ;}
    break;

  case 11:
#line 147 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = (yyvsp[(1) - (1)].node);
	  ;}
    break;

  case 12:
#line 151 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = (yyvsp[(1) - (3)].node);
		node_link_tail((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 13:
#line 159 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = (yyvsp[(1) - (2)].node);
		(yyval.node)->unit[NODE_UNIT_ANGLE] = (yyvsp[(2) - (2)].type);
	  ;}
    break;

  case 14:
#line 164 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = (yyvsp[(1) - (2)].node);
		(yyval.node)->unit[NODE_UNIT_COLOR] = (yyvsp[(2) - (2)].type);
	  ;}
    break;

  case 15:
#line 169 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = (yyvsp[(1) - (2)].node);
		(yyval.node)->unit[NODE_UNIT_RATIO] = (yyvsp[(2) - (2)].type);
	  ;}
    break;

  case 16:
#line 174 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = (yyvsp[(1) - (2)].node);
		(yyval.node)->unit[NODE_UNIT_SIZE] = (yyvsp[(2) - (2)].type);
	  ;}
    break;

  case 17:
#line 179 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = (yyvsp[(1) - (2)].node);
		(yyval.node)->unit[NODE_UNIT_SPEED] = (yyvsp[(2) - (2)].type);
	  ;}
    break;

  case 18:
#line 184 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = (yyvsp[(1) - (2)].node);
		(yyval.node)->unit[NODE_UNIT_TIME] = (yyvsp[(2) - (2)].type);
	  ;}
    break;

  case 19:
#line 189 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_FIELD, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 20:
#line 195 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_SUBSCRIPT, (yylsp[(1) - (4)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (4)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (4)].node));
	  ;}
    break;

  case 21:
#line 201 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_EXPAND, (yylsp[(1) - (4)]).first_line);
		node_link_left((yyval.node), (yyvsp[(3) - (4)].node));
	  ;}
    break;

  case 22:
#line 206 "src/sswf/sswf_grammar.y"
    {
		if((yyvsp[(2) - (3)].node)->next != NULL) {
			/* Check whether the expr returns a list of nodes...
			 * This happens when a comma is used between multiple expressions.
			 * We need to have a 'GROUP' node because all the children are affected
			 * by the following token(s) such as a UNIT.
			 */
			(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_GROUP, (yylsp[(1) - (3)]).first_line);
			node_link_left((yyval.node), (yyvsp[(2) - (3)].node));
		}
		else {
			/* no worry, we don't need to add another node */
		  	(yyval.node) = (yyvsp[(2) - (3)].node);
		}
	  ;}
    break;

  case 23:
#line 222 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_IDENTITY, (yylsp[(1) - (2)]).first_line);
		node_link_left((yyval.node), (yyvsp[(2) - (2)].node));
	  ;}
    break;

  case 24:
#line 227 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_NEGATE, (yylsp[(1) - (2)]).first_line);
		node_link_left((yyval.node), (yyvsp[(2) - (2)].node));
	  ;}
    break;

  case 25:
#line 232 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_LOGICAL_NOT, (yylsp[(1) - (2)]).first_line);
		node_link_left((yyval.node), (yyvsp[(2) - (2)].node));
	  ;}
    break;

  case 26:
#line 237 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_NOT, (yylsp[(1) - (2)]).first_line);
		node_link_left((yyval.node), (yyvsp[(2) - (2)].node));
	  ;}
    break;

  case 27:
#line 242 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_FUNCTION, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		/* right = NULL -- no parameters */
	  ;}
    break;

  case 28:
#line 248 "src/sswf/sswf_grammar.y"
    {
	  	(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_FUNCTION, (yylsp[(1) - (4)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (4)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (4)].node));
	  ;}
    break;

  case 29:
#line 254 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_POWER, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 30:
#line 260 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_MULTIPLY, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 31:
#line 266 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_DIVIDE, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 32:
#line 272 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_MODULO, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 33:
#line 278 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_ADD, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 34:
#line 284 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_SUBTRACT, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 35:
#line 290 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_MINIMUM, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 36:
#line 296 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_MAXIMUM, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 37:
#line 302 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_SHIFT_LEFT, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 38:
#line 308 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_SHIFT_RIGHT, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 39:
#line 314 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_SHIFT_RIGHT_UNSIGNED, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 40:
#line 320 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_ROTATE_LEFT, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 41:
#line 326 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_ROTATE_RIGHT, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 42:
#line 332 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_EQUAL, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 43:
#line 338 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_NOT_EQUAL, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 44:
#line 344 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_LESS, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 45:
#line 350 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_LESS_EQUAL, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 46:
#line 356 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_GREATER, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 47:
#line 362 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_GREATER_EQUAL, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 48:
#line 368 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_AND, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 49:
#line 374 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_XOR, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 50:
#line 380 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_OR, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 51:
#line 386 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_LOGICAL_AND, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 52:
#line 392 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_LOGICAL_XOR, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 53:
#line 398 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_LOGICAL_OR, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 54:
#line 404 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_RANGE, (yylsp[(1) - (3)]).first_line);
		if((yyvsp[(1) - (3)].node)->type == NODE_TYPE_OPERATOR && (yyvsp[(1) - (3)].node)->sub_type == NODE_SUBTYPE_RANGE) {
			fprintf(stderr, "ERROR: at line #%d: can't have two ranges defined one after another.\n", (yylsp[(2) - (3)]).first_line);
			return -1;
		}
		if((yyvsp[(3) - (3)].node)->type == NODE_TYPE_OPERATOR && (yyvsp[(3) - (3)].node)->sub_type == NODE_SUBTYPE_RANGE) {
			fprintf(stderr, "ERROR: at line #%d: can't have two ranges defined one after another.\n", (yylsp[(2) - (3)]).first_line);
			return -1;
		}
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 55:
#line 418 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_SELECT, (yylsp[(1) - (5)]).first_line);
		node_link_select((yyval.node), (yyvsp[(1) - (5)].node));
		node_link_left((yyval.node), (yyvsp[(3) - (5)].node));
		node_link_right((yyval.node), (yyvsp[(5) - (5)].node));
	  ;}
    break;

  case 56:
#line 425 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_IF, (yylsp[(1) - (9)]).first_line);
		node_link_select((yyval.node), (yyvsp[(3) - (9)].node));
		node_link_left((yyval.node), (yyvsp[(6) - (9)].node));
		node_link_right((yyval.node), (yyvsp[(9) - (9)].node));	/* may be a null pointer */
	  ;}
    break;

  case 57:
#line 432 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OBJECT, NODE_SUBTYPE_VARIABLE, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
		node_link_object((yyval.node));
	  ;}
    break;

  case 58:
#line 439 "src/sswf/sswf_grammar.y"
    {
	  	(yyval.node) = (yyvsp[(1) - (1)].node);
	  ;}
    break;

  case 59:
#line 443 "src/sswf/sswf_grammar.y"
    {
	  	(yyval.node) = (yyvsp[(1) - (1)].node);
	  ;}
    break;

  case 60:
#line 447 "src/sswf/sswf_grammar.y"
    {
	  	(yyval.node) = (yyvsp[(1) - (1)].node);
	  ;}
    break;

  case 61:
#line 451 "src/sswf/sswf_grammar.y"
    {
	  	(yyval.node) = (yyvsp[(1) - (1)].node);
	  ;}
    break;

  case 62:
#line 459 "src/sswf/sswf_grammar.y"
    {
	  	(yyval.node) = NULL;
	  ;}
    break;

  case 63:
#line 463 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = (yyvsp[(3) - (5)].node);
	  ;}
    break;

  case 64:
#line 467 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_IF, (yylsp[(1) - (10)]).first_line);
		node_link_select((yyval.node), (yyvsp[(4) - (10)].node));
		node_link_left((yyval.node), (yyvsp[(7) - (10)].node));
		node_link_right((yyval.node), (yyvsp[(10) - (10)].node));	/* may be a null pointer */
	  ;}
    break;

  case 65:
#line 478 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = (yyvsp[(1) - (6)].node);
		/* keep only non-empty names, it simplifies some other parts of the code! */
		if((yyvsp[(2) - (6)].node) != NULL && (yyvsp[(2) - (6)].node)->string != NULL && *(yyvsp[(2) - (6)].node)->string != '\0') {
			node_link_left((yyval.node), (yyvsp[(2) - (6)].node));
		}
		node_link_right((yyval.node), (yyvsp[(4) - (6)].node));
		node_link_object((yyval.node));
	  ;}
    break;

  case 66:
#line 488 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = (yyvsp[(1) - (5)].node);
		if((yyvsp[(2) - (5)].node) != NULL && (yyvsp[(2) - (5)].node)->string != NULL && *(yyvsp[(2) - (5)].node)->string != '\0') {
			node_link_left((yyval.node), (yyvsp[(2) - (5)].node));
		}
		/* right = NULL -- no data for this object */
		node_link_object((yyval.node));
	  ;}
    break;

  case 67:
#line 497 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = (yyvsp[(1) - (2)].node);
		if((yyvsp[(2) - (2)].node) != NULL && (yyvsp[(2) - (2)].node)->string != NULL && *(yyvsp[(2) - (2)].node)->string != '\0') {
			node_link_left((yyval.node), (yyvsp[(2) - (2)].node));
		}
		/* right = NULL -- no data for this object */
		node_link_object((yyval.node));
	  ;}
    break;

  case 68:
#line 506 "src/sswf/sswf_grammar.y"
    { sswf_read_actionscript(1); ;}
    break;

  case 69:
#line 508 "src/sswf/sswf_grammar.y"
    { sswf_read_actionscript(0); ;}
    break;

  case 70:
#line 510 "src/sswf/sswf_grammar.y"
    {
	  	struct node_t	*n;

		/*
		 * Note: we use the 1st line of the STRING so we can generate
		 * proper errors in the Javascript compiler.
		 */
		(yyval.node) = node_alloc(NODE_TYPE_OBJECT, NODE_SUBTYPE_ACTION_SCRIPT, (yylsp[(5) - (7)]).first_line);
		if((yyvsp[(2) - (7)].node) != NULL && (yyvsp[(2) - (7)].node)->string != NULL && *(yyvsp[(2) - (7)].node)->string != '\0') {
			node_link_left((yyval.node), (yyvsp[(2) - (7)].node));
		}
	  	n = node_alloc(NODE_TYPE_DEFINITION, NODE_SUBTYPE_UNKNOWN, (yylsp[(1) - (7)]).first_line);
		/* left = NULL -- no label */
		node_link_right(n, (yyvsp[(5) - (7)].node));
		node_link_right((yyval.node), n);
		node_link_object((yyval.node));
	  ;}
    break;

  case 71:
#line 532 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = NULL;
	  ;}
    break;

  case 72:
#line 536 "src/sswf/sswf_grammar.y"
    {
	  	(yyval.node) = (yyvsp[(1) - (1)].node);
	  ;}
    break;

  case 73:
#line 540 "src/sswf/sswf_grammar.y"
    {
	  	(yyval.node) = (yyvsp[(1) - (1)].node);
	  ;}
    break;

  case 74:
#line 552 "src/sswf/sswf_grammar.y"
    {
	  	(yyval.node) = (yyvsp[(1) - (1)].node);
	  ;}
    break;

  case 75:
#line 556 "src/sswf/sswf_grammar.y"
    {
		(yyval.node) = (yyvsp[(1) - (3)].node);
		node_link_tail((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 76:
#line 565 "src/sswf/sswf_grammar.y"
    {
	  	(yyval.node) = node_alloc(NODE_TYPE_DEFINITION, NODE_SUBTYPE_UNKNOWN, (yylsp[(1) - (3)]).first_line);
		node_link_left((yyval.node), (yyvsp[(1) - (3)].node));
		node_link_right((yyval.node), (yyvsp[(3) - (3)].node));
	  ;}
    break;

  case 77:
#line 571 "src/sswf/sswf_grammar.y"
    {
	  	(yyval.node) = node_alloc(NODE_TYPE_DEFINITION, NODE_SUBTYPE_UNKNOWN, (yylsp[(1) - (1)]).first_line);
		/* left = NULL -- no label */
		node_link_right((yyval.node), (yyvsp[(1) - (1)].node));
	  ;}
    break;

  case 78:
#line 577 "src/sswf/sswf_grammar.y"
    {
		struct node_t	*for_obj, *var, *result, *block;

		block = node_alloc(NODE_TYPE_OBJECT, NODE_SUBTYPE_BLOCK, (yylsp[(1) - (14)]).first_line);
		/* node_link_left() -- no name/label */
		node_link_right(block, (yyvsp[(12) - (14)].node));

		var = node_alloc(NODE_TYPE_OBJECT, NODE_SUBTYPE_VARIABLE, (yylsp[(1) - (14)]).first_line);
		result = node_alloc(NODE_TYPE_INTEGER, NODE_SUBTYPE_UNKNOWN, (yylsp[(1) - (14)]).first_line);
		node_link_left(var, (yyvsp[(3) - (14)].node));
		node_link_right(var, result);	/* the result of different expr's */
		node_link_object(var);

		node_link_tail(var, (yyvsp[(5) - (14)].node));
		node_link_tail(var, (yyvsp[(7) - (14)].node));
		node_link_tail(var, (yyvsp[(9) - (14)].node));
		node_link_tail(var, block);

		for_obj = node_alloc(NODE_TYPE_OBJECT, NODE_SUBTYPE_FOR, (yylsp[(1) - (14)]).first_line);
		/*node_link_left(for_obj, ...) -- no name for a loop - should we use the variable name? */
		node_link_right(for_obj, var);
		/*node_link_object(for_obj);	-- this makes this software crash and it's not necessary (no name!) */

	  	(yyval.node) = node_alloc(NODE_TYPE_DEFINITION, NODE_SUBTYPE_UNKNOWN, (yylsp[(1) - (14)]).first_line);
		/* left = NULL -- no label */
		node_link_right((yyval.node), for_obj);
	  ;}
    break;


/* Line 1267 of yacc.c.  */
#line 2434 "tmp/object/src/sswf/sswf_grammar.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }

  yyerror_range[0] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[0] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[0] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;

  yyerror_range[1] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the look-ahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, (yyerror_range - 1), 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 607 "src/sswf/sswf_grammar.y"



void yyerror(const char *msg)
{
	/* TODO: enhance this message! */
	printf("YACC ERROR at line #%d in file \"%s\": %s.\n", yylloc.first_line, lex_filename, msg);
}





